package calcolatrice;

import java.awt.EventQueue;
import java.awt.Font;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JTextField;
import javax.swing.KeyStroke;
import javax.swing.SpringLayout;
import javax.swing.SwingConstants;

public class Main extends JFrame {

	private JTextField txtNumero;

	private double n1 = 0.0, n2 = 0.0;
	private char op = '=';

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main frame = new Main();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public Main() {
		setTitle("Calcolatrice");
		setBounds(100, 100, 450, 200);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setIconImage(Toolkit.getDefaultToolkit().getImage(Main.class.getResource("/calcolatrice/immagini/calcolatrice.png")));

		JMenuBar menuBar = new JMenuBar();
		setJMenuBar(menuBar);

		JMenu mnTipo = new JMenu("Tipo");
		mnTipo.setMnemonic('T');
		menuBar.add(mnTipo);

		JMenuItem mntmBase = new JMenuItem("Base");
		mntmBase.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_B, InputEvent.CTRL_MASK));
		mnTipo.add(mntmBase);

		JMenuItem mntmScientifica = new JMenuItem("Scientifica");
		mntmScientifica.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_A, InputEvent.CTRL_MASK));
		mnTipo.add(mntmScientifica);

		JMenu mnModifica = new JMenu("Modifica");
		mnModifica.setMnemonic('M');
		menuBar.add(mnModifica);

		JMenuItem mntmTaglia = new JMenuItem("Taglia");
		mntmTaglia.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X, InputEvent.CTRL_MASK));
		mnModifica.add(mntmTaglia);

		JMenuItem mntmCopia = new JMenuItem("Copia");
		mntmCopia.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C, InputEvent.CTRL_MASK));
		mnModifica.add(mntmCopia);

		JMenuItem mntmIncolla = new JMenuItem("Incolla");
		mntmIncolla.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_V, InputEvent.CTRL_MASK));
		mnModifica.add(mntmIncolla);
		SpringLayout springLayout = new SpringLayout();
		getContentPane().setLayout(springLayout);

		txtNumero = new JTextField();
		txtNumero.setHorizontalAlignment(SwingConstants.RIGHT);
		txtNumero.setFont(new Font("Tahoma", Font.PLAIN, 18));
		springLayout.putConstraint(SpringLayout.NORTH, txtNumero, 10, SpringLayout.NORTH, getContentPane());
		springLayout.putConstraint(SpringLayout.WEST, txtNumero, 10, SpringLayout.WEST, getContentPane());
		getContentPane().add(txtNumero);
		txtNumero.setColumns(24);

		JButton btnAddizione = new JButton("+");
		btnAddizione.setFont(new Font("Tahoma", Font.PLAIN, 18));
		springLayout.putConstraint(SpringLayout.NORTH, btnAddizione, 6, SpringLayout.SOUTH, txtNumero);
		springLayout.putConstraint(SpringLayout.WEST, btnAddizione, 0, SpringLayout.WEST, txtNumero);
		btnAddizione.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				addizione();
			}
		});
		getContentPane().add(btnAddizione);

		JButton btnSottrazione = new JButton("-");
		btnSottrazione.setFont(new Font("Tahoma", Font.PLAIN, 18));
		springLayout.putConstraint(SpringLayout.NORTH, btnSottrazione, 6, SpringLayout.SOUTH, txtNumero);
		springLayout.putConstraint(SpringLayout.WEST, btnSottrazione, 6, SpringLayout.EAST, btnAddizione);
		btnSottrazione.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				sottrazione();
			}
		});
		getContentPane().add(btnSottrazione);

		JButton btnMoltiplicazione = new JButton("\u00D7");
		btnMoltiplicazione.setFont(new Font("Tahoma", Font.PLAIN, 18));
		springLayout.putConstraint(SpringLayout.NORTH, btnMoltiplicazione, 6, SpringLayout.SOUTH, txtNumero);
		springLayout.putConstraint(SpringLayout.WEST, btnMoltiplicazione, 6, SpringLayout.EAST, btnSottrazione);
		btnMoltiplicazione.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				moltiplicazione();
			}
		});
		getContentPane().add(btnMoltiplicazione);

		JButton btnDivisione = new JButton(":");
		btnDivisione.setFont(new Font("Tahoma", Font.PLAIN, 18));
		springLayout.putConstraint(SpringLayout.NORTH, btnDivisione, 6, SpringLayout.SOUTH, txtNumero);
		springLayout.putConstraint(SpringLayout.WEST, btnDivisione, 6, SpringLayout.EAST, btnMoltiplicazione);
		btnDivisione.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				divisione();
			}
		});
		getContentPane().add(btnDivisione);

		JButton btnUguale = new JButton("=");
		btnUguale.setFont(new Font("Tahoma", Font.PLAIN, 18));
		springLayout.putConstraint(SpringLayout.NORTH, btnUguale, 6, SpringLayout.SOUTH, txtNumero);
		springLayout.putConstraint(SpringLayout.WEST, btnUguale, 6, SpringLayout.EAST, btnDivisione);
		btnUguale.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				uguale();
			}
		});
		getContentPane().add(btnUguale);

		JButton btnCancella = new JButton("C");
		btnCancella.setFont(new Font("Tahoma", Font.PLAIN, 18));
		springLayout.putConstraint(SpringLayout.NORTH, btnCancella, 6, SpringLayout.SOUTH, txtNumero);
		springLayout.putConstraint(SpringLayout.WEST, btnCancella, 6, SpringLayout.EAST, btnUguale);
		btnCancella.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				cancella();
			}
		});
		getContentPane().add(btnCancella);
	}

	public void addizione() {
		n1 = Double.parseDouble(txtNumero.getText());
		op = '+';
		txtNumero.setText("");
		txtNumero.requestFocus();
	}

	public void sottrazione() {
		n1 = Double.parseDouble(txtNumero.getText());
		op = '-';
		txtNumero.setText("");
		txtNumero.requestFocus();
	}

	public void moltiplicazione() {
		n1 = Double.parseDouble(txtNumero.getText());
		op = '';
		txtNumero.setText("");
		txtNumero.requestFocus();
	}

	public void divisione() {
		n1 = Double.parseDouble(txtNumero.getText());
		op = ':';
		txtNumero.setText("");
		txtNumero.requestFocus();
	}

	public void uguale() {
		n2 = Double.parseDouble(txtNumero.getText());
		double n = 0.0;
		switch (op) {
		case '+':
			n = n1 + n2;
			break;
		case '-':
			n = n1 - n2;
			break;
		case '':
			n = n1 * n2;
			break;
		case ':':
			n = n1 / n2;
			break;
		}
		txtNumero.setText(Double.toString(n));
		op = '=';
		txtNumero.requestFocus();
	}

	public void cancella() {
		n1 = 0.0;
		n2 = 0.0;
		op = '=';
		txtNumero.setText("");
		txtNumero.requestFocus();
	}
}
